/*
 *
 * visualize data from arduino lie an oscilloscope
 *
 */

// import serial library (need to read date from arduino board)
import processing.serial.*;
//import processing.opengl.*;


PFont font;
// The font must be located in the sketch's 
// "data" directory to load successfully


// serial port
Serial port;

// Serial variables
String serialString;
String rxString = null; // Anwort vom Ser Port
int cr = 13; // carriage return
int lf = 10; // line feed


int v1;
int[] va1 = new int[2000];


int f_receive;


int cnt, cnt2;
int td, tm, tma, ratems;
int xax;
int s_width=1024;
int s_height=800;
float tfm;

color cv1= color(255, 0, 0);


// this block is executed one time when programm starts
void setup() {
  font = loadFont("CourierNewPS-BoldMT-48.vlw"); 
  textFont(font); 

  // size of window
  //  size(s_width,s_height,OPENGL);
  size(s_width, s_height);

  // print a list of the serial ports, to get port of arduino
  println("Serial ports");
  println(Serial.list());

  // init serial port, on my computer the arduino port is the first port
  port = new Serial(this, Serial.list()[1], 115200);

  frameRate(25);
  background(0);

  text("Oszilloscope", 500, 30); 
  for (int  ii=0; ii < s_width+10;ii++) {
    va1[ii]=s_height/2;
  }

  tma=millis();
}

// this block is executed in a loop after setup is called one time
void draw() {

  // clear background  
  noStroke();
  fill(0);
  rect(0, 0, width, height);

  cnt2++;
  //     println(cnt+"  "+td);

  for (int  ii=0; ii < s_width;ii++) {
    stroke(cv1); 
    line(ii, va1[ii], ii, va1[ii+1]);
  }


  fill(255);
  text(cnt, s_width-200, 40);

  text(ratems+" ms", s_width-200, 80);
  fill(cv1);
  text(v1, 20, 40);
}
// ***************************************************************
// serial event
void serialEvent(Serial p) {

  // get string till line break (ASCII > 13)
  serialString = port.readStringUntil(13);
  // just if there is data
  if (serialString != null) {
    print(serialString);

    tm=millis();  
    if (cnt > 0) {

      td= tm-tma;
      tfm=tfm+ td;
    }
    ratems=int(tfm/cnt);
    tma=tm;


    // try catch function because of possible garbage in received data
    try {
      String[] message = splitTokens(serialString);
      // get current angle
      v1 = Integer.parseInt(message[0]);


      for (int  ii = s_width; ii >= 0; ii--) {
        va1[ii+1]= va1[ii];
      }

      va1[0]= (s_height/2)+( 512-v1 ) /2;
    }
    catch (Exception e) {
    }
    cnt=cnt+1;
  }
}




